searchNodes=[{"doc":"This is the base Nerves System configuration for the Raspberry Pi 4 Model B. &lt;sup&gt;[Michael Henzler / Wikimedia Commons / CC BY-SA 4.0]( https://en.wikipedia.org/wiki/File:Raspberry_Pi_4_Model_B_-_Top.jpg )&lt;/sup&gt; Feature Description CPU 1.5 GHz quad-core Cortex-A72 (64-bit mode) Memory 1 GB, 2 GB, 4 GB DRAM Storage MicroSD Linux kernel 5.10 w/ Raspberry Pi patches IEx terminal HDMI and USB keyboard (can be changed to UART) GPIO, I2C, SPI Yes - Elixir Circuits ADC No PWM Yes, but no Elixir support UART 1 available - ttyS0 Display HDMI or 7&quot; RPi Touchscreen Camera Untested Ethernet Yes WiFi Yes - VintageNet Bluetooth Untested Audio HDMI/Stereo out","ref":"readme.html","title":"Raspberry Pi 4 Model B (64-bit)","type":"extras"},{"doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=rpi4 . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems .","ref":"readme.html#using","title":"Raspberry Pi 4 Model B (64-bit) - Using","type":"extras"},{"doc":"The base image includes drivers for the onboard Raspberry Pi 4 wifi module ( brcmfmac driver).","ref":"readme.html#supported-wifi-devices","title":"Raspberry Pi 4 Model B (64-bit) - Supported WiFi devices","type":"extras"},{"doc":"The Raspberry Pi has many options for audio output. This system supports the HDMI and stereo audio jack output. The Linux ALSA drivers are used for audio output. The general Raspberry Pi audio documentation mostly applies to Nerves. For example, to force audio out the HDMI port, run: cmd ( &quot;amixer cset numid=3 2&quot; ) Change the last argument to amixer to 1 to output to the stereo output jack.","ref":"readme.html#audio","title":"Raspberry Pi 4 Model B (64-bit) - Audio","type":"extras"},{"doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store's Nerves.Runtime.KV.get/1 function. Keys used by this system are: Key Example Value Description nerves_serial_number &quot;12345678&quot; By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd ( &quot;fw_setenv nerves_serial_number 12345678&quot; ) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you're programming MicroSD cards using fwup , the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf . The default provisioning.conf will set the nerves_serial_number , if you override the location to this file, you will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices","title":"Raspberry Pi 4 Model B (64-bit) - Provisioning devices","type":"extras"},{"doc":"There's a subtle coupling between the nerves_system_br version and the Linux kernel version used here. nerves_system_br provides the versions of rpi-userland and rpi-firmware that get installed. I prefer to match them to the Linux kernel to avoid any issues. Unfortunately, none of these are tagged by the Raspberry Pi Foundation so I either attempt to match what's in Raspbian or take versions of the repositories that have similar commit times.","ref":"readme.html#linux-kernel-and-rpi-firmware-userland","title":"Raspberry Pi 4 Model B (64-bit) - Linux kernel and RPi firmware/userland","type":"extras"},{"doc":"The Linux kernel compiled for Nerves is a stripped down version of the default Raspberry Pi Linux kernel. This is done to remove unnecessary features, select some Nerves-specific features like F2FS and SquashFS support, and to save space.","ref":"readme.html#linux-kernel-configuration","title":"Raspberry Pi 4 Model B (64-bit) - Linux kernel configuration","type":"extras"},{"doc":"This project does NOT follow semantic versioning. The version increases as follows: Major version updates are breaking updates to the build infrastructure. These should be very rare. Minor version updates are made for every major Buildroot release. This may also include Erlang/OTP and Linux kernel updates. These are made four times a year shortly after the Buildroot releases. Patch version updates are made for Buildroot minor releases, Erlang/OTP releases, and Linux kernel updates. They're also made to fix bugs and add features to the build infrastructure.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.20.6 Erlang/OTP 25.0.4 Buildroot 2022.05.2 Also see Buildroot 2022.05.1 changes","ref":"changelog.html#v1-20-2","title":"Changelog - v1.20.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.20.4 Erlang/OTP 25.0.3","ref":"changelog.html#v1-20-1","title":"Changelog - v1.20.1","type":"extras"},{"doc":"This release updates to Buildroot 2022.05, Linux 5.15.32 (from Linux 5.10) and uses GCC 11.3 (from GCC 10.3). The Linux kernel upgrade could introduce a regression, so please verify hardware-specific functionality in your firmware. If you have cloned this repository for a custom system, please make sure that you have CONFIG_NOP_USB_XCEIV=y in your Linux kernel configuration. Updated dependencies nerves_system_br v1.20.3 Buildroot 2022.05 Erlang/OTP 25.0.2","ref":"changelog.html#v1-20-0","title":"Changelog - v1.20.0","type":"extras"},{"doc":"This release updates to Buildroot 2022.02.1 and OTP 25.0. While this should be an easy update for most projects, many programs have been updated. Please review the changes in the updated dependencies for details. The OTP 25 JIT starts by default with this release. Updated dependencies nerves_system_br v1.19.0 Buildroot 2022.02.1 . Also see Buildroot 2022.02 Erlang/OTP 25.0","ref":"changelog.html#v1-19-0","title":"Changelog - v1.19.0","type":"extras"},{"doc":"This release bumps Erlang to 24.3.2 and should be a low risk upgrade from the previous release. Changes Pull in upstream Linux SquashFS patch to improve file system performance Updated dependencies nerves_system_br v1.18.6","ref":"changelog.html#v1-18-4","title":"Changelog - v1.18.4","type":"extras"},{"doc":"This is a Buildroot and Erlang bug and security fix release. It should be a low risk upgrade from the previous release. Updated dependencies nerves_system_br v1.18.5 Changes Enable Prolific PL2303 USB-&gt;Serial driver","ref":"changelog.html#v1-18-3","title":"Changelog - v1.18.3","type":"extras"},{"doc":"This is a Buildroot and Erlang bug fix release. It should be a low risk upgrade from the previous release. Updated dependencies nerves_system_br v1.18.4 Changes Specify CPU-specific flags when compiling NIFs and ports. This fixes an issue where some optimizations could not be enabled in NIFs even though it should be possible to have them. E.g., ARM NEON support for CPUs that have it. Build the Wireguard kernel driver. This is a small device driver that enables a number of VPN-based use cases.","ref":"changelog.html#v1-18-2","title":"Changelog - v1.18.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.18.3 Changes Programs that use OpenMP will run now. The OpenMP shared library ( libgomp.so ) was supplied by the toolchain, but not copied.","ref":"changelog.html#v1-18-1","title":"Changelog - v1.18.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.11 and OTP 24.2. If you have made a custom system, please review the nerves_system_br release notes since Buildroot 2021.11 changed some Raspberry Pi firmware options. Updated dependencies nerves_system_br v1.18.2 Buildroot 2021.11 Erlang/OTP 24.2 Raspberry Pi WiFi firmware Linux 5.10.88 with Raspberry Pi patches GCC 10.3 Improvements Support for the dl.nerves-project.org backup site. Due to a GitHub outage in November, there was a 2 day period of failing builds since some packages could not be downloaded. We implemented the backup site to prevent this in the future. This update is in the nerves_defconfig . Use new build ORB on CircleCI. This ORB will shorten build times to fit in CircleCI's new free tier limits. Please update if building your own systems.","ref":"changelog.html#v1-18-0","title":"Changelog - v1.18.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.17.4 Buildroot 2021.08.2 Erlang/OTP 24.1.7 .","ref":"changelog.html#v1-17-3","title":"Changelog - v1.17.3","type":"extras"},{"doc":"This release updates the Linux kernel from 5.4 to 5.10 to follow the Raspberry Pi OS. Fixes Shrink down the artifact size by reducing duplication in DRI libraries. This has no runtime change. Updated dependencies nerves_system_br v1.17.3 Erlang/OTP 24.1.4 . Linux 5.10.63 with Raspberry Pi patches","ref":"changelog.html#v1-17-2","title":"Changelog - v1.17.2","type":"extras"},{"doc":"This is a security/bug fix patch release. It should be safe to update for everyone. Updated dependencies nerves_system_br v1.17.1 Buildroot 2021.08.1 Erlang/OTP 24.1.2 Fixes Fix the sysfs thermal interface driver. It was incorrectly unselected in the Linux kernel options previously. Improvements Include software versioning and licensing info (see legal-info directory in artifact)","ref":"changelog.html#v1-17-1","title":"Changelog - v1.17.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.08 and OTP 24.1. If you have made a custom system off this one, please review the nerves_system_br v1.17.0 release notes. Updated dependencies nerves_system_br v1.17.0 Buildroot 2021.08 Erlang/OTP 24.1","ref":"changelog.html#v1-17-0","title":"Changelog - v1.17.0","type":"extras"},{"doc":"Improvements Enable USB gadget interface on boot so that the USB-C cable can provide power and networking like the RPi Zero and RPi 3A.","ref":"changelog.html#v1-16-3","title":"Changelog - v1.16.3","type":"extras"},{"doc":"This release updates Erlang/OTP from 24.0.3 to 24.0.5 and Buildroot from 2021.05 to 2021.05.1. Both of these are security/bug fix updates. This is expected to be a safe upgrade from v1.16.1 for all users. Updated dependencies nerves_system_br v1.16.4 Erlang/OTP 24.0.5 Improvements Beta support for using a runtime.exs script for runtime configuration. Added a provision task to the fwup.config to enable re-provisioning a MicroSD card without changing its contents. Adds a default /etc/sysctl.conf that enables use of ICMP in Erlang. This requires nerves_runtime v0.11.5 or later to automatically load the sysctl variables. With it using :gen_udp to send/receive ICMP will &quot;just work&quot;. It also makes it easier to add other sysctl variables if needed.","ref":"changelog.html#v1-16-2","title":"Changelog - v1.16.2","type":"extras"},{"doc":"This release updates Nerves Toolchains to v1.4.3 and OTP 24.0.3. It should be safe for everyone to apply. Updated dependencies nerves_system_br v1.16.1 Erlang/OTP 24.0.3 nerves toolchains v1.4.3","ref":"changelog.html#v1-16-1","title":"Changelog - v1.16.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.05 and OTP 24.0.2. If you have made a custom system off this one, please review the nerves_system_br v1.16.0 release notes. Updated dependencies nerves_system_br v1.16.0 Buildroot 2021.05 Erlang/OTP 24.0.2 Improvements This release now contains debug symbols and includes the Build-ID in the ELF headers. This makes it easier to get stack traces from C programs. As before, the Nerves tooling strips all symbols from firmware images, so this won't make programs bigger. Enable compile-time wpa_supplicant options to support WPA3, mesh networking, WPS and autoscan.","ref":"changelog.html#v1-16-0","title":"Changelog - v1.16.0","type":"extras"},{"doc":"This is a security/bug fix release that updates to Buildroot 2021.02.1 and OTP 23.3.1. It should be safe for everyone to apply. Improvements Raspberry Pi CM4 support espeak has been removed from the default install to trim 13 MB off the root filesystem Updated dependencies Linux 5.4.83 - required for CM4 device tree updates nerves_system_br v1.15.1 Buildroot 2021.02 Erlang/OTP 23.3.1","ref":"changelog.html#v1-15-1","title":"Changelog - v1.15.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.02 and OTP 23.2.7. If you have made a custom system off this one, please review the nerves_system_br v1.15.0 release notes. The Nerves toolchain has also been updated to v1.4.2. This brings in Linux 4.14 headers to enable use of cdev and eBPF. This won't affect most users. Updated dependencies nerves_system_br v1.15.0 Buildroot 2021.02 Erlang/OTP 23.2.7 nerves toolchains v1.4.2","ref":"changelog.html#v1-15-0","title":"Changelog - v1.15.0","type":"extras"},{"doc":"This release updates to Buildroot 2020.11.2, GCC 10.2 and OTP 23.2.4. When migrating custom systems based, please be aware of the following important changes: There's a new getrandom syscall that is made early in BEAM startup. This has the potential to block the BEAM before Nerves can start rngd to provide entropy. We have not seen this issue here, but have updated erlinit.config for the time being as a precaution. The GCC 10.2.0 toolchain has a different name that calls out &quot;nerves&quot; as the vendor and the naming is now more consistent with other toolchain providers. Experimental support for tooling that requires more information about the target has been added. The initial support focuses on zigler. Updated dependencies nerves_system_br: bump to v1.14.4 Buildroot 2020.11.2 Erlang/OTP 23.2.4 Nerves toolchains 1.4.1","ref":"changelog.html#v1-14-0","title":"Changelog - v1.14.0","type":"extras"},{"doc":"This release adds missing V3D/VC4 drivers and enables the vc4-fkms-v3d device tree overlay. This fixes issues found when trying out OpenGLES w/ DRM.","ref":"changelog.html#v1-13-5","title":"Changelog - v1.13.5","type":"extras"},{"doc":"This releases enables the OpenGL ES drivers so that it's possible to run UI libraries without a custom system. Note that the RPi4 uses the Linux DRM interface rather than MMAL and so it is not compatible with Elixir UI libraries that work on other Raspberry Pis. Updated dependencies nerves_system_br: bump to v1.13.7 Erlang/OTP 23.1.5","ref":"changelog.html#v1-13-3","title":"Changelog - v1.13.3","type":"extras"},{"doc":"This release fixes the following issues found with the switch to 64-bit ARM: Circuits.GPIO can't set pullups 5 GHz WiFi is either flaky or doesn't work No GPU drivers A huge thanks for people in the Nerves community that identified these issues and helped verify the fixes. This release also includes a patch release update to Buildroot 2020.08.2 . Updated dependencies nerves_system_br: bump to v1.13.5 erlinit 1.9.0","ref":"changelog.html#v1-13-2","title":"Changelog - v1.13.2","type":"extras"},{"doc":"IMPORTANT: This release runs the RPi4 in 64-bit ARM mode. This change was made for many reasons. See https://github.com/nerves-project/nerves_system_rpi4/issues/65 for details. While this is a big change, it is likely that it will not affect your programs at all. The second change in this release is to bump the Linux kernel to 5.4. This follows the kernel update in the Raspberry Pi OS. If you have based a custom system off of this one, please inspect all configuration files for changes. In particular, WiFi firmware location has changed since the rpi-wifi-firmware package went out of date. Git commit messages on the nerves_system_rpi4 repository may also be helpful. Updated dependencies nerves_system_br: bump to v1.13.4 Erlang/OTP 23.1.4 boardid 1.10.0 Improvements Enabled reproducible builds in Buildroot to remove some timestamp and build path differences in firmware images. This helps delta firmware updates. The memory cgroup controller is no longer enabled by default. This was an upstream change. As a result, the memory cgroup directory is no longer mounted.","ref":"changelog.html#v1-13-1","title":"Changelog - v1.13.1","type":"extras"},{"doc":"This release updates to Buildroot 2020.08 and OTP 23.1.1. Updated dependencies nerves_system_br: bump to v1.13.2 Erlang/OTP 23.1.1 erlinit 1.8.0 nerves 1.7.0 New features Added support for updating the root filesystem using firmware patches. See the firmware patch docs for more information.","ref":"changelog.html#v1-13-0","title":"Changelog - v1.13.0","type":"extras"},{"doc":"This release updates to Buildroot 2020.05.1 and OTP 23.0.3 which are both bug fix releases. IMPORTANT: If you have made a custom fwup.conf file, then you'll need to replace references to start4.elf with start.elf and references to fixup4.dat with fixup.dat . See commit e21ad76 for how this change was made here. Updated dependencies nerves_system_br: bump to v1.12.4 Erlang/OTP 23.0.3 nerves_heart v0.3.0 New features The /data directory now exists for storing application-specific data. It is currently a symlink to /root . Using /data will eventually be encouraged over /root even though currently there is no advantage. This change makes it possible to start migrating paths in applications and libraries. Fixes Fixed old references to the -Os compiler flag. All C/C++ code will default to using -O2 now.","ref":"changelog.html#v1-12-2","title":"Changelog - v1.12.2","type":"extras"},{"doc":"Fixes Remove nerves_system_linter from hex package. This fixes mix dependency errors in projects that reference systems with different nerves_system_linter dependency specs.","ref":"changelog.html#v1-12-1","title":"Changelog - v1.12.1","type":"extras"},{"doc":"This release updates the system to use Buildroot 2020.05 and Erlang/OTP 23. Please see the respective release notes for updates and deprecations in both projects for changes that may affect your application. New features Support the Raspberry Pi Sense HAT's joystick Enable WiFi mesh support in the 802.11 stack Updated dependencies nerves_system_br v1.12.0 Erlang/OTP 23.0.2 Linux 4.19.118 (Raspberry Pi 1.2020601 tag) Raspberry Pi firmware 1.2020601","ref":"changelog.html#v1-12-0","title":"Changelog - v1.12.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.4 Erlang 22.3.4.1 fwup 1.7.0","ref":"changelog.html#v1-11-3","title":"Changelog - v1.11.3","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.2 Erlang 22.3.1 erlinit 1.7.0 - tty initialization support fwup 1.6.0 - xdelta3/VCDIFF patch support Enable unixodbc so that Erlang's odbc application can be used in projects","ref":"changelog.html#v1-11-2","title":"Changelog - v1.11.2","type":"extras"},{"doc":"This release updates the Linux configuration to match changes in the latest Raspberry Pi kernel configuration for the Raspberry Pi 4. If you have made a custom system, the following kernel configuration changes may affect you: + CONFIG_CPUFREQ_DT = y + CONFIG_ARM_RASPBERRYPI_CPUFREQ = y + # CONFIG_ARM_BCM2835_CPUFREQ is not set + CONFIG_RPIVID_MEM = m + CONFIG_REGULATOR_FIXED_VOLTAGE = y + CONFIG_DRM_V3D = m + CONFIG_CLK_RASPBERRYPI = y Bug fixes Fixed regulator kernel configuration setting that prevented booting sometimes (this was a &quot;not sure how this ever worked&quot; kind of bug)","ref":"changelog.html#v1-11-1","title":"Changelog - v1.11.1","type":"extras"},{"doc":"This release updates Buildroot to 2020.02 and upgrades gcc from 8.3 to 9.2. While this is a minor version bump due to the Buildroot release update, barring advanced usage of Nerves, this is a straightforward update from v1.10.2. Updated dependencies nerves_system_br v1.11.0 linux 4.19.97 (raspberrypi-kernel_1.20200212-1 tag) Erlang 22.2.8","ref":"changelog.html#v1-11-0","title":"Changelog - v1.11.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.10.2 Erlang 22.2.4","ref":"changelog.html#v1-10-2","title":"Changelog - v1.10.2","type":"extras"},{"doc":"Enhancements Set expand=true on the application data partition. This will only take effect for users running the complete task, fwup will not expand application data partitions that exist during upgrade tasks. Updated dependencies nerves_system_br v1.10.1 Erlang 22.2.3","ref":"changelog.html#v1-10-1","title":"Changelog - v1.10.1","type":"extras"},{"doc":"This release updates Buildroot to 2019.11 with security and bug fix updates across Linux packages. Enables dnsd, udhcpd and ifconfig in the default Busybox configuration to support vintage_net and vintage_net_wizard . See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.10.0 Erlang 22.1.8","ref":"changelog.html#v1-10-0","title":"Changelog - v1.10.0","type":"extras"},{"doc":"This release updates Buildroot to 2019.08.2 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Erlang/OTP is now at 22.1.7. Updated dependencies nerves_system_br v1.9.5","ref":"changelog.html#v1-9-2","title":"Changelog - v1.9.2","type":"extras"},{"doc":"This release pulls in security and bug fix updates from nerves_system_br . Erlang/OTP is now at 22.1.1. IMPORTANT: The IEx prompt was being output on the UART. This was inconsistent with other Nerves/Raspberry Pi systems and has been fixed. If you want to use the UART, you'll need to override the erlinit.config file. Bug fixes Default to displaying the iex prompt on the HDMI port like the other Raspberry Pi systems Compile in the I2C drivers so they're available early on for NervesKey and other use at initialization Updated dependencies nerves_system_br v1.9.4 linux - update to the raspberrypi-kernel_1.20190925-1 tag","ref":"changelog.html#v1-9-1","title":"Changelog - v1.9.1","type":"extras"},{"doc":"NOTE: bootcode.bin is not used by the RPi 4 and is no longer built. If updating a fork of this project, be sure to remove references to it from your fwup.conf. See https://www.raspberrypi.org/documentation/hardware/raspberrypi/booteeprom.md This release updates Buildroot to 2019.08 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.9.2 Enhancements Support a variety of USB-&gt;UART adapters so more devices work out-of-the-box","ref":"changelog.html#v1-9-0","title":"Changelog - v1.9.0","type":"extras"},{"doc":"This release fixes an issue that broke display output on small LCD screens. Updating the Raspberry Pi firmware to the latest from the Raspberry Pi Foundation fixed the issue. See https://github.com/fhunleth/rpi_fb_capture/issues/2 for details. Updated dependencies nerves_system_br v1.8.5","ref":"changelog.html#v1-8-2","title":"Changelog - v1.8.2","type":"extras"},{"doc":"This is the initial Nerves System release for the Raspberry Pi 4. It's version corresponds to other Nerves System releases for Raspberry Pi's for ease of referring to version numbers. While similar looking, the Raspberry Pi 4 has some significant differences with other Raspberry Pis. The following functionality appears to work so far: Support for up to 4 GB of DRAM (1 GB and 2 GB versions supported too) I2C, SPI, and GPIO - The RPi 4 has additional pin mux options. They have not been tested. The primary UART has not been redirected away from the Bluetooth module. This is useful for using BLE with the Harald library, but is different from the other RPi defaults The Pi Camera and Raspberry Pi Foundation 7&quot; Touchscreen both work Gigabit Ethernet works WiFi appears to work USB 3 devices The following major features have not been tested: OpenGL support and HDMI output USB Gadget mode via the USB C connector (the gadget drivers are currently enabled, though) Additionally, the Raspberry Pi 4 port uses 32-bit mode on the ARM even though the processor supports 64-bit usage. 64-bit usage didn't build when tried and the Raspberry Pi Foundation promotes 32-bit usage so that's what's used here. Primary constituent project versions Erlang 22.0.7 nerves_system_br v1.8.4 nerves_toolchain_arm_unknown_linux_gnueabihf v1.2.0","ref":"changelog.html#v1-8-1","title":"Changelog - v1.8.1","type":"extras"}]